/* valaobjecttypesymbol.c generated by valac, the Vala compiler
 * generated from valaobjecttypesymbol.vala, do not modify */

/* valaobjecttypesymbol.vala
 *
 * Copyright (C) 2008-2009  Jürg Billeter
 * Copyright (C) 2008  Philip Van Hoof
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 * 	Philip Van Hoof <pvanhoof@gnome.org>
 */

#include <glib.h>
#include <glib-object.h>
#include "vala.h"
#include <valagee.h>
#include <stdlib.h>
#include <string.h>

#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))

struct _ValaObjectTypeSymbolPrivate {
	ValaList* type_parameters;
};


static gpointer vala_object_type_symbol_parent_class = NULL;

#define VALA_OBJECT_TYPE_SYMBOL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbolPrivate))
static ValaList* vala_object_type_symbol_real_get_methods (ValaObjectTypeSymbol* self);
static ValaList* vala_object_type_symbol_real_get_signals (ValaObjectTypeSymbol* self);
static ValaList* vala_object_type_symbol_real_get_properties (ValaObjectTypeSymbol* self);
static gint vala_object_type_symbol_real_get_type_parameter_index (ValaTypeSymbol* base, const gchar* name);
static void vala_object_type_symbol_finalize (ValaCodeNode * obj);


ValaObjectTypeSymbol* vala_object_type_symbol_construct (GType object_type, const gchar* name, ValaSourceReference* source_reference, ValaComment* comment) {
	ValaObjectTypeSymbol* self = NULL;
	const gchar* _tmp0_;
	ValaSourceReference* _tmp1_;
	ValaComment* _tmp2_;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = name;
	_tmp1_ = source_reference;
	_tmp2_ = comment;
	self = (ValaObjectTypeSymbol*) vala_typesymbol_construct (object_type, _tmp0_, _tmp1_, _tmp2_);
	return self;
}


static ValaList* vala_object_type_symbol_real_get_methods (ValaObjectTypeSymbol* self) {
	g_critical ("Type `%s' does not implement abstract method `vala_object_type_symbol_get_methods'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


ValaList* vala_object_type_symbol_get_methods (ValaObjectTypeSymbol* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return VALA_OBJECT_TYPE_SYMBOL_GET_CLASS (self)->get_methods (self);
}


static ValaList* vala_object_type_symbol_real_get_signals (ValaObjectTypeSymbol* self) {
	g_critical ("Type `%s' does not implement abstract method `vala_object_type_symbol_get_signals'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


ValaList* vala_object_type_symbol_get_signals (ValaObjectTypeSymbol* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return VALA_OBJECT_TYPE_SYMBOL_GET_CLASS (self)->get_signals (self);
}


static ValaList* vala_object_type_symbol_real_get_properties (ValaObjectTypeSymbol* self) {
	g_critical ("Type `%s' does not implement abstract method `vala_object_type_symbol_get_properties'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


ValaList* vala_object_type_symbol_get_properties (ValaObjectTypeSymbol* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return VALA_OBJECT_TYPE_SYMBOL_GET_CLASS (self)->get_properties (self);
}


/**
 * Appends the specified parameter to the list of type parameters.
 *
 * @param p a type parameter
 */
void vala_object_type_symbol_add_type_parameter (ValaObjectTypeSymbol* self, ValaTypeParameter* p) {
	ValaList* _tmp0_;
	ValaTypeParameter* _tmp1_;
	ValaScope* _tmp2_;
	ValaScope* _tmp3_;
	ValaTypeParameter* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	ValaTypeParameter* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = self->priv->type_parameters;
	_tmp1_ = p;
	vala_collection_add ((ValaCollection*) _tmp0_, _tmp1_);
	_tmp2_ = vala_symbol_get_scope ((ValaSymbol*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = p;
	_tmp5_ = vala_symbol_get_name ((ValaSymbol*) _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = p;
	vala_scope_add (_tmp3_, _tmp6_, (ValaSymbol*) _tmp7_);
}


/**
 * Returns a copy of the type parameter list.
 *
 * @return list of type parameters
 */
static gpointer _vala_iterable_ref0 (gpointer self) {
	return self ? vala_iterable_ref (self) : NULL;
}


ValaList* vala_object_type_symbol_get_type_parameters (ValaObjectTypeSymbol* self) {
	ValaList* result = NULL;
	ValaList* _tmp0_;
	ValaList* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->type_parameters;
	_tmp1_ = _vala_iterable_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


static gint vala_object_type_symbol_real_get_type_parameter_index (ValaTypeSymbol* base, const gchar* name) {
	ValaObjectTypeSymbol * self;
	gint result = 0;
	gint i = 0;
	self = (ValaObjectTypeSymbol*) base;
	g_return_val_if_fail (name != NULL, 0);
	i = 0;
	{
		ValaList* _parameter_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _parameter_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _parameter_index = 0;
		_tmp0_ = self->priv->type_parameters;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_parameter_list = _tmp1_;
		_tmp2_ = _parameter_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_parameter_size = _tmp4_;
		_parameter_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ValaTypeParameter* parameter = NULL;
			ValaList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			ValaTypeParameter* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gint _tmp15_;
			_tmp5_ = _parameter_index;
			_parameter_index = _tmp5_ + 1;
			_tmp6_ = _parameter_index;
			_tmp7_ = _parameter_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _parameter_list;
			_tmp9_ = _parameter_index;
			_tmp10_ = vala_list_get (_tmp8_, _tmp9_);
			parameter = (ValaTypeParameter*) _tmp10_;
			_tmp11_ = parameter;
			_tmp12_ = vala_symbol_get_name ((ValaSymbol*) _tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = name;
			if (g_strcmp0 (_tmp13_, _tmp14_) == 0) {
				result = i;
				_vala_code_node_unref0 (parameter);
				_vala_iterable_unref0 (_parameter_list);
				return result;
			}
			_tmp15_ = i;
			i = _tmp15_ + 1;
			_vala_code_node_unref0 (parameter);
		}
		_vala_iterable_unref0 (_parameter_list);
	}
	result = -1;
	return result;
}


ValaObjectType* vala_object_type_symbol_get_this_type (ValaObjectTypeSymbol* self) {
	ValaObjectType* result = NULL;
	ValaObjectType* _result_ = NULL;
	ValaObjectType* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = vala_object_type_new (self);
	_result_ = _tmp0_;
	{
		ValaList* _type_parameter_list = NULL;
		ValaList* _tmp1_;
		gint _type_parameter_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _type_parameter_index = 0;
		_tmp1_ = vala_object_type_symbol_get_type_parameters (self);
		_type_parameter_list = _tmp1_;
		_tmp2_ = _type_parameter_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_type_parameter_size = _tmp4_;
		_type_parameter_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ValaTypeParameter* type_parameter = NULL;
			ValaList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			ValaGenericType* type_arg = NULL;
			ValaTypeParameter* _tmp11_;
			ValaGenericType* _tmp12_;
			ValaGenericType* _tmp13_;
			ValaObjectType* _tmp14_;
			ValaGenericType* _tmp15_;
			_tmp5_ = _type_parameter_index;
			_type_parameter_index = _tmp5_ + 1;
			_tmp6_ = _type_parameter_index;
			_tmp7_ = _type_parameter_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _type_parameter_list;
			_tmp9_ = _type_parameter_index;
			_tmp10_ = vala_list_get (_tmp8_, _tmp9_);
			type_parameter = (ValaTypeParameter*) _tmp10_;
			_tmp11_ = type_parameter;
			_tmp12_ = vala_generic_type_new (_tmp11_);
			type_arg = _tmp12_;
			_tmp13_ = type_arg;
			vala_data_type_set_value_owned ((ValaDataType*) _tmp13_, TRUE);
			_tmp14_ = _result_;
			_tmp15_ = type_arg;
			vala_data_type_add_type_argument ((ValaDataType*) _tmp14_, (ValaDataType*) _tmp15_);
			_vala_code_node_unref0 (type_arg);
			_vala_code_node_unref0 (type_parameter);
		}
		_vala_iterable_unref0 (_type_parameter_list);
	}
	result = _result_;
	return result;
}


/**
 * Adds the specified method as a hidden member to this class,
 * primarily used for default signal handlers.
 *
 * The hidden methods are not part of the `methods` collection.
 *
 * There may also be other use cases, eg, convert array.resize() to
 * this type of method?
 *
 * @param m a method
 */
void vala_object_type_symbol_add_hidden_method (ValaObjectTypeSymbol* self, ValaMethod* m) {
	ValaMethod* _tmp0_;
	ValaMemberBinding _tmp1_;
	ValaMemberBinding _tmp2_;
	gboolean _tmp30_ = FALSE;
	ValaMethod* _tmp31_;
	ValaDataType* _tmp32_;
	ValaDataType* _tmp33_;
	ValaScope* _tmp61_;
	ValaScope* _tmp62_;
	ValaMethod* _tmp63_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	_tmp0_ = m;
	_tmp1_ = vala_method_get_binding (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == VALA_MEMBER_BINDING_INSTANCE) {
		ValaMethod* _tmp3_;
		ValaParameter* _tmp4_;
		ValaParameter* _tmp5_;
		ValaMethod* _tmp14_;
		ValaObjectType* _tmp15_;
		ValaObjectType* _tmp16_;
		ValaParameter* _tmp17_;
		ValaParameter* _tmp18_;
		ValaMethod* _tmp19_;
		ValaScope* _tmp20_;
		ValaScope* _tmp21_;
		ValaMethod* _tmp22_;
		ValaParameter* _tmp23_;
		ValaParameter* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		ValaMethod* _tmp27_;
		ValaParameter* _tmp28_;
		ValaParameter* _tmp29_;
		_tmp3_ = m;
		_tmp4_ = vala_method_get_this_parameter (_tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_ != NULL) {
			ValaMethod* _tmp6_;
			ValaScope* _tmp7_;
			ValaScope* _tmp8_;
			ValaMethod* _tmp9_;
			ValaParameter* _tmp10_;
			ValaParameter* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			_tmp6_ = m;
			_tmp7_ = vala_symbol_get_scope ((ValaSymbol*) _tmp6_);
			_tmp8_ = _tmp7_;
			_tmp9_ = m;
			_tmp10_ = vala_method_get_this_parameter (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp12_ = vala_symbol_get_name ((ValaSymbol*) _tmp11_);
			_tmp13_ = _tmp12_;
			vala_scope_remove (_tmp8_, _tmp13_);
		}
		_tmp14_ = m;
		_tmp15_ = vala_object_type_symbol_get_this_type (self);
		_tmp16_ = _tmp15_;
		_tmp17_ = vala_parameter_new ("this", (ValaDataType*) _tmp16_, NULL);
		_tmp18_ = _tmp17_;
		vala_method_set_this_parameter (_tmp14_, _tmp18_);
		_vala_code_node_unref0 (_tmp18_);
		_vala_code_node_unref0 (_tmp16_);
		_tmp19_ = m;
		_tmp20_ = vala_symbol_get_scope ((ValaSymbol*) _tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = m;
		_tmp23_ = vala_method_get_this_parameter (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = vala_symbol_get_name ((ValaSymbol*) _tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = m;
		_tmp28_ = vala_method_get_this_parameter (_tmp27_);
		_tmp29_ = _tmp28_;
		vala_scope_add (_tmp21_, _tmp26_, (ValaSymbol*) _tmp29_);
	}
	_tmp31_ = m;
	_tmp32_ = vala_callable_get_return_type ((ValaCallable*) _tmp31_);
	_tmp33_ = _tmp32_;
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp33_, VALA_TYPE_VOID_TYPE)) {
		ValaMethod* _tmp34_;
		ValaList* _tmp35_;
		ValaList* _tmp36_;
		gint _tmp37_;
		gint _tmp38_;
		_tmp34_ = m;
		_tmp35_ = vala_method_get_postconditions (_tmp34_);
		_tmp36_ = _tmp35_;
		_tmp37_ = vala_collection_get_size ((ValaCollection*) _tmp36_);
		_tmp38_ = _tmp37_;
		_tmp30_ = _tmp38_ > 0;
		_vala_iterable_unref0 (_tmp36_);
	} else {
		_tmp30_ = FALSE;
	}
	if (_tmp30_) {
		ValaMethod* _tmp39_;
		ValaLocalVariable* _tmp40_;
		ValaLocalVariable* _tmp41_;
		ValaMethod* _tmp50_;
		ValaMethod* _tmp51_;
		ValaDataType* _tmp52_;
		ValaDataType* _tmp53_;
		ValaDataType* _tmp54_;
		ValaDataType* _tmp55_;
		ValaLocalVariable* _tmp56_;
		ValaLocalVariable* _tmp57_;
		ValaMethod* _tmp58_;
		ValaLocalVariable* _tmp59_;
		ValaLocalVariable* _tmp60_;
		_tmp39_ = m;
		_tmp40_ = vala_subroutine_get_result_var ((ValaSubroutine*) _tmp39_);
		_tmp41_ = _tmp40_;
		if (_tmp41_ != NULL) {
			ValaMethod* _tmp42_;
			ValaScope* _tmp43_;
			ValaScope* _tmp44_;
			ValaMethod* _tmp45_;
			ValaLocalVariable* _tmp46_;
			ValaLocalVariable* _tmp47_;
			const gchar* _tmp48_;
			const gchar* _tmp49_;
			_tmp42_ = m;
			_tmp43_ = vala_symbol_get_scope ((ValaSymbol*) _tmp42_);
			_tmp44_ = _tmp43_;
			_tmp45_ = m;
			_tmp46_ = vala_subroutine_get_result_var ((ValaSubroutine*) _tmp45_);
			_tmp47_ = _tmp46_;
			_tmp48_ = vala_symbol_get_name ((ValaSymbol*) _tmp47_);
			_tmp49_ = _tmp48_;
			vala_scope_remove (_tmp44_, _tmp49_);
		}
		_tmp50_ = m;
		_tmp51_ = m;
		_tmp52_ = vala_callable_get_return_type ((ValaCallable*) _tmp51_);
		_tmp53_ = _tmp52_;
		_tmp54_ = vala_data_type_copy (_tmp53_);
		_tmp55_ = _tmp54_;
		_tmp56_ = vala_local_variable_new (_tmp55_, "result", NULL, NULL);
		_tmp57_ = _tmp56_;
		vala_subroutine_set_result_var ((ValaSubroutine*) _tmp50_, _tmp57_);
		_vala_code_node_unref0 (_tmp57_);
		_vala_code_node_unref0 (_tmp55_);
		_tmp58_ = m;
		_tmp59_ = vala_subroutine_get_result_var ((ValaSubroutine*) _tmp58_);
		_tmp60_ = _tmp59_;
		vala_local_variable_set_is_result (_tmp60_, TRUE);
	}
	_tmp61_ = vala_symbol_get_scope ((ValaSymbol*) self);
	_tmp62_ = _tmp61_;
	_tmp63_ = m;
	vala_scope_add (_tmp62_, NULL, (ValaSymbol*) _tmp63_);
}


static void vala_object_type_symbol_class_init (ValaObjectTypeSymbolClass * klass) {
	vala_object_type_symbol_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_object_type_symbol_finalize;
	g_type_class_add_private (klass, sizeof (ValaObjectTypeSymbolPrivate));
	((ValaObjectTypeSymbolClass *) klass)->get_methods = (ValaList* (*) (ValaObjectTypeSymbol *)) vala_object_type_symbol_real_get_methods;
	((ValaObjectTypeSymbolClass *) klass)->get_signals = (ValaList* (*) (ValaObjectTypeSymbol *)) vala_object_type_symbol_real_get_signals;
	((ValaObjectTypeSymbolClass *) klass)->get_properties = (ValaList* (*) (ValaObjectTypeSymbol *)) vala_object_type_symbol_real_get_properties;
	((ValaTypeSymbolClass *) klass)->get_type_parameter_index = (gint (*) (ValaTypeSymbol *, const gchar*)) vala_object_type_symbol_real_get_type_parameter_index;
}


static void vala_object_type_symbol_instance_init (ValaObjectTypeSymbol * self) {
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	self->priv = VALA_OBJECT_TYPE_SYMBOL_GET_PRIVATE (self);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_TYPE_TYPEPARAMETER, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp0_);
	self->priv->type_parameters = (ValaList*) _tmp1_;
}


static void vala_object_type_symbol_finalize (ValaCodeNode * obj) {
	ValaObjectTypeSymbol * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol);
	_vala_iterable_unref0 (self->priv->type_parameters);
	VALA_CODE_NODE_CLASS (vala_object_type_symbol_parent_class)->finalize (obj);
}


/**
 * Represents a runtime data type for objects and interfaces. This data type may
 * be defined in Vala source code or imported from an external library with a 
 * Vala API file.
 */
GType vala_object_type_symbol_get_type (void) {
	static volatile gsize vala_object_type_symbol_type_id__volatile = 0;
	if (g_once_init_enter (&vala_object_type_symbol_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaObjectTypeSymbolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_object_type_symbol_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaObjectTypeSymbol), 0, (GInstanceInitFunc) vala_object_type_symbol_instance_init, NULL };
		GType vala_object_type_symbol_type_id;
		vala_object_type_symbol_type_id = g_type_register_static (VALA_TYPE_TYPESYMBOL, "ValaObjectTypeSymbol", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&vala_object_type_symbol_type_id__volatile, vala_object_type_symbol_type_id);
	}
	return vala_object_type_symbol_type_id__volatile;
}



